Figma integration: operations for AI agents
Figma connects to Type.com as an integration. This page lists the 59 operations documented for Claude and Codex in Type.com: 44 read, 9 write, 6 destructive.
About Figma
Figma REST vendor API references, subject to vendor permissions and account availability.
Categories: Design & Media
How to connect Figma to Type.com
- Connect
- Managed OAuth through Pipedream when enabled for your workspace; API key
- Access
- Organization connection: one shared account for the workspace.
To add the connection, follow the steps in Space connections.
Documented operations
59 operations. Your connection's permissions determine which operations are available. API references describe the vendor surface; they do not expand your connection's credentials or access.
59 operations listed.
Files
- Read
Get file JSON
Returns the document identified by `file_key` as a JSON object. The file key can be parsed from any Figma file url: `https://www.figma.com/file/{file_key}/{title}`. The `document` property contains a node of type `DOCUMENT`. The `components` property contains a mapping from node IDs to component metadata. This is to help you determine which components each instance comes from.
GET /v1/files/{file_key} - Read
Get file JSON for specific nodes
Returns the nodes referenced to by `ids` as a JSON object. The nodes are retrieved from the Figma file referenced to by `file_key`. The node ID and file key can be parsed from any Figma node url: `https://www.figma.com/file/{file_key}/{title}?node-id={id}` The `name`, `lastModified`, `thumbnailUrl`, `editorType`, and `version` attributes are all metadata of the specified file. The `linkAccess` field describes the file link share permission level. There are 5 types of permissions a shared link can have: `"inherit"`, `"view"`, `"edit"`, `"org_view"`, and `"org_edit"`. `"inherit"` is the default permission applied to files created in a team project, and will inherit the project's permissions. `"org_view"` and `"org_edit"` restrict the link to org users. The `document` attribute contains a Node of type `DOCUMENT`. The `components` key contains a mapping from node IDs to component metadata. This is to help you determine which components each instance comes from. By default, no vector data is returned. To return vector data, pass the geometry=paths parameter to the endpoint. Each node can also inherit properties from applicable styles. The styles key contains a mapping from style IDs to style metadata. Important: the nodes map may contain values that are `null`. This may be due to the node id not existing within the specified file.
GET /v1/files/{file_key}/nodes - Read
Render images of file nodes
Renders images from a file. If no error occurs, `"images"` will be populated with a map from node IDs to URLs of the rendered images, and `"status"` will be omitted. The image assets will expire after 30 days. Images up to 32 megapixels can be exported. Any images that are larger will be scaled down. Important: the image map may contain values that are `null`. This indicates that rendering of that specific node has failed. This may be due to the node id not existing, or other reasons such has the node having no renderable components. It is guaranteed that any node that was requested for rendering will be represented in this map whether or not the render succeeded. To render multiple images from the same file, use the `ids` query parameter to specify multiple node ids. ``` GET /v1/images/:key?ids=1:2,1:3,1:4 ```
GET /v1/images/{file_key} - Read
Get image fills
Returns download links for all images present in image fills in a document. Image fills are how Figma represents any user supplied images. When you drag an image into Figma, we create a rectangle with a single fill that represents the image, and the user is able to transform the rectangle (and properties on the fill) as they wish. This endpoint returns a mapping from image references to the URLs at which the images may be download. Image URLs will expire after no more than 14 days. Image references are located in the output of the GET files endpoint under the `imageRef` attribute in a `Paint`.
GET /v1/files/{file_key}/images - Read
Get file metadata
Get file metadata
GET /v1/files/{file_key}/meta - Read
Get versions of a file
This endpoint fetches the version history of a file, allowing you to see the progression of a file over time. You can then use this information to render a specific version of the file, via another endpoint.
GET /v1/files/{file_key}/versions - Write
Duplicate a file
Duplicates a main file or branch into the specified folder as a new standalone file. The source file and destination folder must belong to the Enterprise plan associated with the private OAuth app. The authenticated user must be able to export the source file, edit the destination folder, and create files of the source editor type. The copy uses the source's latest saved checkpoint and may not include recent unsaved changes. This endpoint is available only to Enterprise plans.
POST /v1/files/{file_key}/duplicate
Teams
- Read
Get a team
Returns metadata for a team the caller can access. Private OAuth apps can use this endpoint for Professional, Organization, and Enterprise plans. Plan access tokens can use it for Organization and Enterprise plans.
GET /v1/teams/{team_id} - Write
Create a team
Creates a team in the Enterprise plan associated with a private OAuth app. The app uses the authenticated user's permissions, and that user becomes the team owner. The request is subject to the same team-creation controls and permissions as team creation in Figma.
POST /v1/teams - Write
Invite users to a team
Invites users to a team with the requested role. This endpoint is available only to private OAuth apps associated with an Enterprise plan, and the team must belong to that plan. The authenticated user must be allowed to grant the requested role on the team. Each email address is processed independently. Per-address failures are returned in `errors` with HTTP 200, even if `invites` is empty. Always check `errors` to determine which addresses could not be invited. Existing team members keep their current role when it is higher than the requested role.
POST /v1/teams/{team_id}/invites
Projects
- Read
[Deprecated] Get projects in a team (deprecated)
Deprecated in favor of [Get top-level folders in a team](https://developers.figma.com/docs/rest-api/folders-endpoints/). You can use this endpoint to get a list of the top-level Projects (now called "folders") within the specified team. This will only return projects visible to the authenticated user or owner of the developer token. Note: it is not currently possible to programmatically obtain the team id of a user just from a token. To obtain a team id, navigate to a team page of a team you are a part of. The team id will be present in the URL after the word team and before your team name.
GET /v1/teams/{team_id}/projects - Read
[Deprecated] Get project metadata (deprecated)
Deprecated in favor of [Get folder metadata](https://developers.figma.com/docs/rest-api/folders-endpoints/). Get metadata for a project (now called a "folder").
GET /v1/projects/{project_id}/meta - Read
[Deprecated] Get files in a project (deprecated)
Deprecated in favor of [Get files in a folder](https://developers.figma.com/docs/rest-api/folders-endpoints/). Get a list of all the Files within the specified project (now called a "folder").
GET /v1/projects/{project_id}/files
Folders
- Read
Get top-level folders in a team
Get a list of the top-level folders (previously called "projects") within the specified team. Subfolders can be traversed with the GET /v2/folders/{folder_id}/folders endpoint. It is not possible to programmatically obtain team IDs. To obtain a team ID, navigate to the team page in the Figma file browser. The team ID is present in the URL after the word team. For example, in `https://www.figma.com/files/181033233908053158/team/1535685101263221741`, the team ID is `1535685101263221741`.
GET /v2/teams/{team_id}/folders - Read
Get subfolders in a folder
Get a list of the direct subfolders within the specified folder.
GET /v2/folders/{folder_id}/folders - Read
Get files in a folder
Get a list of the files directly within the specified folder.
GET /v2/folders/{folder_id}/files - Read
Get folder metadata
Get metadata for a folder (name, thumbnail, file count, timestamps) without enumerating its files.
GET /v2/folders/{folder_id}/meta - Write
Create a folder
Creates a top-level folder in a team. The team must belong to the Enterprise plan associated with the private OAuth app, and the authenticated user must be allowed to create a folder in the team.
POST /v1/teams/{team_id}/folders
Comments
- Read
Get comments in a file
Gets a list of comments left on the file.
GET /v1/files/{file_key}/comments - Write
Add a comment to a file
Posts a new comment on the file.
POST /v1/files/{file_key}/comments - Destructive
Delete a comment
Deletes a specific comment. Only the person who made the comment is allowed to delete it.
DELETE /v1/files/{file_key}/comments/{comment_id}
Comment Reactions
- Read
Get reactions for a comment
Gets a paginated list of reactions left on the comment.
GET /v1/files/{file_key}/comments/{comment_id}/reactions - Write
Add a reaction to a comment
Posts a new comment reaction on a file comment.
POST /v1/files/{file_key}/comments/{comment_id}/reactions - Destructive
Delete a reaction
Deletes a specific comment reaction. Only the person who made the reaction is allowed to delete it.
DELETE /v1/files/{file_key}/comments/{comment_id}/reactions
Users
- Read
Get current user
Returns the user information for the currently authenticated user.
GET /v1/me
Components
- Read
Get team components
Get a paginated list of published components within a team library.
GET /v1/teams/{team_id}/components - Read
Get file components
Get a list of published components within a file library.
GET /v1/files/{file_key}/components - Read
Get component
Get metadata on a component by key.
GET /v1/components/{key}
Component Sets
- Read
Get team component sets
Get a paginated list of published component sets within a team library.
GET /v1/teams/{team_id}/component_sets - Read
Get file component sets
Get a list of published component sets within a file library.
GET /v1/files/{file_key}/component_sets - Read
Get component set
Get metadata on a published component set by key.
GET /v1/component_sets/{key}
Styles
- Read
Get team styles
Get a paginated list of published styles within a team library.
GET /v1/teams/{team_id}/styles - Read
Get file styles
Get a list of published styles within a file library.
GET /v1/files/{file_key}/styles - Read
Get style
Get metadata on a style by key.
GET /v1/styles/{key}
Webhooks
- Read
Get webhooks by context or plan
Returns a list of webhooks corresponding to the context or plan provided, if they exist. For plan, the webhooks for all contexts that you have access to will be returned, and theresponse is paginated
GET /v2/webhooks - Read
Get a webhook
Get a webhook by ID.
GET /v2/webhooks/{webhook_id} - Read
[Deprecated] Get team webhooks (deprecated)
Returns all webhooks registered under the specified team.
GET /v2/teams/{team_id}/webhooks - Read
Get webhook requests
Returns all webhook requests sent within the last week. Useful for debugging.
GET /v2/webhooks/{webhook_id}/requests - Write
Create a webhook
Create a new webhook which will call the specified endpoint when the event triggers. By default, this webhook will automatically send a PING event to the endpoint when it is created. If this behavior is not desired, you can create the webhook and set the status to PAUSED and reactivate it later.
POST /v2/webhooks - Destructive
Update a webhook
Update a webhook by ID.
PUT /v2/webhooks/{webhook_id} - Destructive
Delete a webhook
Deletes the specified webhook. This operation cannot be reversed.
DELETE /v2/webhooks/{webhook_id}
Activity Logs
- Read
Get activity logs
Returns a list of activity log events
GET /v1/activity_logs
Developer Logs
- Read
Get developer logs
Returns a list of developer log entries for REST API and MCP server requests made within the organization. This endpoint requires a plan access token with the `org:developer_log_read` scope.
POST /v1/developer_logs
AI Usage
- Read
Get daily AI credit usage
Returns per-user, per-day AI credit usage for the plan associated with the calling token. This endpoint requires a plan access token with the `org:ai_metering_usage_read` scope.
GET /v1/ai_usage/daily
Payments
- Read
Get payments
There are two methods to query for a user's payment information on a plugin, widget, or Community file. The first method, using plugin payment tokens, is typically used when making queries from a plugin's or widget's code. The second method, providing a user ID and resource ID, is typically used when making queries from anywhere else. Note that you can only query for resources that you own. In most cases, this means that you can only query resources that you originally created.
GET /v1/payments
Variables
- Read
Get local variables
**This API is available to full members of Enterprise orgs.** The `GET /v1/files/:file_key/variables/local` endpoint lets you enumerate local variables created in the file and remote variables used in the file. Remote variables are referenced by their `subscribed_id`. As a part of the Variables related API additions, the `GET /v1/files/:file_key` endpoint now returns a `boundVariables` property, containing the `variableId` of the bound variable. The `GET /v1/files/:file_key/variables/local` endpoint can be used to get the full variable or variable collection object. Note that `GET /v1/files/:file_key/variables/published` does not return modes. Instead, you will need to use the `GET /v1/files/:file_key/variables/local` endpoint, in the same file, to examine the mode values.
GET /v1/files/{file_key}/variables/local - Read
Get published variables
**This API is available to full members of Enterprise orgs.** The `GET /v1/files/:file_key/variables/published` endpoint returns the variables that are published from the given file. The response for this endpoint contains some key differences compared to the `GET /v1/files/:file_key/variables/local` endpoint: - Each variable and variable collection contains a `subscribed_id`. - Modes are omitted for published variable collections Published variables have two ids: an id that is assigned in the file where it is created (`id`), and an id that is used by subscribing files (`subscribed_id`). The `id` and `key` are stable over the lifetime of the variable. The `subscribed_id` changes every time the variable is modified and published. The same is true for variable collections. The `updatedAt` fields are ISO 8601 timestamps that indicate the last time that a change to a variable was published. For variable collections, this timestamp will change any time a variable in the collection is changed.
GET /v1/files/{file_key}/variables/published - Destructive
Create/modify/delete variables
**This API is available to full members of Enterprise orgs with Editor seats.** The `POST /v1/files/:file_key/variables` endpoint lets you bulk create, update, and delete variables and variable collections. The request body supports the following 4 top-level arrays. Changes from these arrays will be applied in the below order, and within each array, by array order. - **variableCollections**: For creating, updating, and deleting variable collections - **variableModes**: For creating, updating, and deleting modes within variable collections - Each collection can have a maximum of 40 modes - Mode names cannot be longer than 40 characters - **variables**: For creating, updating, and deleting variables - Each collection can have a maximum of 5000 variables - Variable names must be unique within a collection and cannot contain certain special characters such as `.{}` - **variableModeValues**: For setting a variable value under a specific mode. - When setting aliases, a variable cannot be aliased to itself or form an alias cycle - Color variables can use a composed color value with `color` and `opacity` fields. At least one field must be a variable alias. Temporary ids can be used to reference an object later in the same POST request body. They can be used at create time in the `id` property of variable collections, modes, variables, and in the `initialModeId` property of variable collections. They are scoped to a single request body, and must be unique within the body. The mapping of temporary ids to real ids is returned in the response. This endpoint has the following key behaviors: - The request body must be 4MB or less. - Must include an `action` property for collections, modes, and variables to tell the API whether to create, update, or delete the object. - When creating a collection, mode, or variable, you can include a temporary `id` that can be referenced in dependent objects in the same request. For example, you can create a new collection with the id `"my_new_collection"`. You can then set `variableCollectionId` to `"my_new_collection"` in new modes or variables. Temporary ids must be unique in the request body. - New collections always come with one mode. You can reference this mode by setting `initialModeId` to a temporary id in the request body. This is useful if you want to set values for variables in the mode in the `variableModeValues` array. - The `tempIdToRealId` array returns a mapping of the temporary ids in the request, to the real ids of the newly created objects. - When adding new modes or variables, default variable values will be applied, consistent with what happens in the UI. - Everything to be created, updated, and deleted in the request body is treated as one atomic operation. If there is any validation failure, you will get a 400 status code response, and no changes will be persisted. - You will not be able to update remote variables or variable collections. You can only update variables in the file where they were originally created.
POST /v1/files/{file_key}/variables
Dev Resources
- Read
Get dev resources
Get dev resources in a file
GET /v1/files/{file_key}/dev_resources - Write
Create dev resources
Bulk create dev resources across multiple files. Dev resources that are successfully created will show up in the links_created array in the response. If there are any dev resources that cannot be created, you may still get a 200 response. These resources will show up in the errors array. Some reasons a dev resource cannot be created include: - Resource points to a `file_key` that cannot be found. - The node already has the maximum of 10 dev resources. - Another dev resource for the node has the same url.
POST /v1/dev_resources - Write
Update dev resources
Bulk update dev resources across multiple files. Ids for dev resources that are successfully updated will show up in the `links_updated` array in the response. If there are any dev resources that cannot be updated, you may still get a 200 response. These resources will show up in the `errors` array.
PUT /v1/dev_resources - Destructive
Delete dev resource
Delete a dev resource from a file
DELETE /v1/files/{file_key}/dev_resources/{dev_resource_id}
Library Analytics
- Read
Get library analytics component action data.
Returns a list of library analytics component actions data broken down by the requested dimension.
GET /v1/analytics/libraries/{file_key}/component/actions - Read
Get library analytics component usage data.
Returns a list of library analytics component usage data broken down by the requested dimension.
GET /v1/analytics/libraries/{file_key}/component/usages - Read
Get library analytics style action data.
Returns a list of library analytics style actions data broken down by the requested dimension.
GET /v1/analytics/libraries/{file_key}/style/actions - Read
Get library analytics style usage data.
Returns a list of library analytics style usage data broken down by the requested dimension.
GET /v1/analytics/libraries/{file_key}/style/usages - Read
Get library analytics variable action data.
Returns a list of library analytics variable actions data broken down by the requested dimension.
GET /v1/analytics/libraries/{file_key}/variable/actions - Read
Get library analytics variable usage data.
Returns a list of library analytics variable usage data broken down by the requested dimension.
GET /v1/analytics/libraries/{file_key}/variable/usages
oEmbed
- Read
Get oEmbed data
Returns oEmbed data for a Figma file or published Make site URL, following the [oEmbed specification](https://oembed.com/).
GET /v1/oembed
No operations match.
Get started
- Open Space settings → Connections and search for Figma.
- Connect your account and add the connection to the Space.
- Ask for what you need in any thread in that Space.
See How connections work for access and permissions, or browse all integrations.
Reference date: October 29, 2026. Figma API docs.